package lab.actors 
{
	import as3isolib.display.IsoSprite;
	import lab.actors.api.BaseActor;
	import lab.core.IsoLevel;
	import lab.data.Items;
	import lab.data.ItemVO;
	import lab.display.DataImage;
	import lab.embed.Atlases;
	import lab.registry.Reg;
	import starling.textures.Texture;
	
	/**
	 * ...
	 * @author Roma Kraminskij - kraminskij@gmail.com
	 */
	public class EndLevelActor extends BaseActor 
	{
		
		public function EndLevelActor( item:ItemVO = null, level:IsoLevel = null ) 
		{
			super();
			//if ( item != null && level != null ) start(item, level);
		}
		
		/**
		 * Build actors sprites and actions.
		 * @param	item
		 * @param	level
		 */
		public override function start( item:ItemVO = null, level:IsoLevel=null ):void 
		{
			super.start( item, level );
			
			var texture:Texture = Atlases.getAtlas( "tiles_00" ).getTexture( item.type );
			var image:DataImage = new DataImage( texture, item );
			
			var k:Number = texture.height / texture.width;
			
			image.width = IsoLevel.CELL_SIZE * 2;
			image.height = IsoLevel.CELL_SIZE * 2 * k;
			image.x = -IsoLevel.CELL_SIZE ;
			image.y = -( ( IsoLevel.CELL_SIZE * 2 * k ) - IsoLevel.CELL_SIZE );
			image.smoothing = Reg.TEXTURE_SMOOTHING;
			
			var sprite:IsoSprite = new IsoSprite();
			
			sprite.name = item.type;
			sprite.sprites = [image];
			sprite.data = item;
			sprite.setSize( IsoLevel.CELL_SIZE, IsoLevel.CELL_SIZE, 10 );
			sprite.moveTo( item.x * IsoLevel.CELL_SIZE, item.y * IsoLevel.CELL_SIZE, 1);
			
			level.scene.addChild(sprite);
			
			item.addObj(sprite);
		}
		
		public override function check():void 
		{
			if ( level.isItemsHasTypeOfXY( Items.PLAYER, item.x, item.x ) ) 
			{
				level.onLevelEnd.dispatch();
			}
		}
	}

}