package lab.actors 
{
	import as3isolib.core.IsoDisplayObject;
	import lab.actors.api.BaseActor;
	
	import as3isolib.display.IsoSprite;
	import as3isolib.geom.IsoMath;
	import as3isolib.geom.Pt;
	import feathers.controls.List;
	import feathers.controls.renderers.DefaultListItemRenderer;
	import flash.events.KeyboardEvent;
	import flash.ui.Keyboard;
	import lab.core.IsoLevel;
	import lab.data.Items;
	import lab.data.ItemVO;
	import lab.embed.Atlases;
	import starling.animation.Tween;
	import starling.core.Starling;
	import starling.display.DisplayObject;
	import starling.display.Image;
	import starling.display.MovieClip;
	import starling.events.Event;
	import starling.events.Touch;
	import starling.events.TouchEvent;
	import starling.events.TouchPhase;
	import starling.textures.Texture;
	/**
	 * ...
	 * @author Roma Kraminskij - kraminskij@gmail.com
	 */
	public class PlayerActor extends BaseActor 
	{
		public var isoXT					: int		= 0; // New coords for moving.
		public var isoYT					: int 		= 0;
		
		private var mc						: MovieClip = null;
		private var isDown					: Boolean 	= false;
		private var isUp					: Boolean 	= false;
		private var isRight					: Boolean	= false;
		private var isLeft					: Boolean 	= false;
		private var isMovingState			: Boolean 	= false;
		private var moveDirection			: int 		= 0;
		private var isAcceeptMove			: Boolean 	= false;
		private var isAcceeptMoveBox		: Boolean	= false;
		private var boxItem					: ItemVO	= null;
		private var overX					: Number	= 0;
		private var overY					: Number	= 0;
		
		public function PlayerActor( item:ItemVO = null, level:IsoLevel = null ) 
		{
			super();
			
			//if ( item != null && level != null ) start(item, level);
		}
		/**
		 * Build actors sprites and actions.
		 * @param	item
		 * @param	level
		 */
		public override function start( item:ItemVO = null, level:IsoLevel=null ):void 
		{
			super.start( item, level );
			
			mc = new MovieClip( Atlases.getAtlas( "heylee_00" ).getTextures( "right_down" ), 6 );
			mc.scaleX = mc.scaleY = 1;
			Starling.current.juggler.add( mc );
		
			mc.x = -mc.width /  2;
			mc.y = -mc.height + IsoLevel.CELL_SIZE;
			
			var sprite:IsoSprite = new IsoSprite();
			
			sprite.name = item.type;
			sprite.sprites = [mc];
			sprite.data = item;
			sprite.setSize(IsoLevel.CELL_SIZE-1, IsoLevel.CELL_SIZE-1, IsoLevel.CELL_SIZE*2);
			sprite.moveTo(item.x * IsoLevel.CELL_SIZE-1, item.y * IsoLevel.CELL_SIZE-1, 1);
			
			level.scene.addChild(sprite);
			
			item.addObj( sprite );
			
			mc.addEventListener( Event.ADDED_TO_STAGE, addHandler );
			mc.addEventListener( Event.REMOVED_FROM_STAGE, removeHandler );
			
			isoXT = item.x;
			isoYT = item.y;
		}
		/**
		 * 
		 * @param	e
		 */
	
		private function keyHandler(e:KeyboardEvent):void
		{
			// Down or up key. TRUE for down.
			var state:Boolean = ( e.type == KeyboardEvent.KEY_DOWN );
			
			switch ( e.keyCode )
			{
				case Keyboard.DOWN: isDown = state; break;
				case Keyboard.UP: isUp = state; break;
				case Keyboard.RIGHT: isRight = state; break;
				case Keyboard.LEFT: isLeft = state; break;
				default: break;
			}
			
			if ( state ) setDirection();
		}
		/**
		 * 
		 */
		private function setDirection():void
		{
			if ( isMovingState ) return
				
			var oldIsoX:int = isoXT;
			var oldIsoY:int = isoYT;
			
			isAcceeptMove = false;
			isAcceeptMoveBox = false;
			
			isDown 	 ? isoXT++ : 0;
			isUp	 ? isoXT-- : 0;
			isRight  ? isoYT-- : 0;
			isLeft 	 ? isoYT++ : 0;
			
			overX = item.x + (isoXT - oldIsoX) * 2;
			overY = item.y + (isoYT - oldIsoY) * 2;
			// Check is floor in target cell.
			if ( level.isItemsHasTypeOfXY( Items.FLOOR, isoXT, isoYT ) ) isAcceeptMove = true;
			// If end cell, move here.
			if ( level.isItemsHasTypeOfXY( Items.END, isoXT, isoYT ) ) isAcceeptMove = true;
			if ( level.isItemsHasTypeOfXY( Items.TRIGGER, isoXT, isoYT ) ) isAcceeptMove = true;
			// Check box and floor over it, so move this.
			if ( level.isItemsHasTypeOfXY( Items.BOX, isoXT, isoYT ) && ( level.isItemsHasTypeOfXY( Items.FLOOR, overX, overY ) ||
				level.isItemsHasTypeOfXY( Items.TRIGGER, overX, overY ) ) )
			{
				isAcceeptMove = true;
				isAcceeptMoveBox = true;
			}
			// Check box and wall over it.
			if ( level.isItemsHasTypeOfXY( Items.BOX, isoXT, isoYT ) && level.isItemsHasTypeOfXY( Items.WALL, overX, overY ) )
				isAcceeptMove = false;
			// If other player actor, do not assemble.
			if ( level.isItemsHasTypeOfXY( Items.PLAYER, isoXT, isoYT ) ) isAcceeptMove = false;
			// Door and Auto door.
			if ( level.isItemsHasTypeOfXY( Items.DOOR, isoXT, isoYT ) )
			{
				if ( level.getItemTypeOfXY( Items.DOOR, isoXT, isoYT ).source.custom[0].@state == "up" ) isAcceeptMove = false
					else isAcceeptMove = true;
			}
			if ( level.isItemsHasTypeOfXY( Items.AUTO_DOOR, isoXT, isoYT ) )
			{
				if ( level.getItemTypeOfXY( Items.AUTO_DOOR, isoXT, isoYT ).source.custom[0].@state == "up" ) isAcceeptMove = false
					else isAcceeptMove = true;
			}
			
			if ( isAcceeptMove ) 
			{
				isMovingState = true;
				// Move cosmo.
				var tw:Tween = new Tween( item.sprites[0], 0.5 );
				tw.moveTo( isoXT * IsoLevel.CELL_SIZE, isoYT * IsoLevel.CELL_SIZE );
				tw.onUpdate = animationUpdate;
				tw.onComplete = playerEndMove;
				Starling.current.juggler.add( tw );
				// Move box.
				if ( isAcceeptMoveBox )
				{
					// Move box to next cell.
					boxItem = level.getItemTypeOfXY( Items.BOX, isoXT, isoYT); 
					var box:IsoDisplayObject = boxItem.sprites[0] ;
					
					var tw2:Tween = new Tween( box, 0.5 );
					//boxItem.x = overX; boxItem.y = overY;
					tw2.moveTo( overX * IsoLevel.CELL_SIZE, overY * IsoLevel.CELL_SIZE );
					Starling.current.juggler.add( tw2 );
				}
				else {
					boxItem = null;
				}
			}
			else
			{
				isoXT = oldIsoX;
				isoYT = oldIsoY;
				isMovingState = false;
			}
		}
		
		private function playerEndMove():void 
		{
			item.x = isoXT;
			item.y = isoYT;
			
			if ( boxItem != null ) // Check for box has moving.
			{
				boxItem.x = overX;
				boxItem.y = overY;
			}
			
			boxItem = null;	
			
			level.checkActors();
			
			isMovingState = false;
			
			
		}
		
		private function animationUpdate():void 
		{
			level.isNeedUpdate = true;
		}
		
		private function addHandler(e:Event):void 
		{
			mc.removeEventListener(Event.ADDED_TO_STAGE, addHandler);
			
			Starling.current.nativeStage.addEventListener( KeyboardEvent.KEY_DOWN, keyHandler );
			Starling.current.nativeStage.addEventListener( KeyboardEvent.KEY_UP, keyHandler );
		}
		
		private function removeHandler(e:Event):void 
		{
			if ( e.target is DisplayObject )
				e.target.removeEventListener(Event.REMOVED_FROM_STAGE, removeHandler);
			
			Starling.current.nativeStage.removeEventListener( KeyboardEvent.KEY_DOWN, keyHandler );
			Starling.current.nativeStage.removeEventListener( KeyboardEvent.KEY_UP, keyHandler );
		}
		
		public override function update():void 
		{
			
		}
		
		public override function check():void
		{
			
		}
		
		public override function end():void 
		{
			
		}
		
	}

}













































