package lab.embed
{
	import avmplus.getQualifiedClassName;
	
	import flash.display.Bitmap;
	import flash.utils.Dictionary;
	import flash.utils.describeType;
	
	import starling.textures.Texture;
	import starling.textures.TextureAtlas;

	public class Atlases
	{
		[Embed(source="/assets/textures/gui_00.xml", mimeType="application/octet-stream")] private const atlas_02:Class;
		[Embed(source = "/assets/textures/gui_00.png")]	private const gui_00:Class;
		
		[Embed(source="/assets/textures/heylee_00.xml", mimeType="application/octet-stream")] private const heylee_00:Class;
		[Embed(source = "/assets/textures/heylee_00.png")]	private const heylee_01:Class;
		
		[Embed(source="/assets/textures/tiles_00.xml", mimeType="application/octet-stream")] private const tiles_00:Class;
		[Embed(source="/assets/textures/tiles_00.png")]	private const tiles_01:Class;
		
		[Embed(source="/assets/templates/objects_00.xml", mimeType="application/octet-stream")] private const objects_00:Class;
		
		public static var instance:Atlases;
		
		private var atlases:Dictionary = new Dictionary();
		private var textures:Dictionary = new Dictionary();
		
		private var sourceAtlasesXML:Vector.<Class> = new <Class>[ atlas_02, heylee_00, tiles_00 ];
		private var sourceTextures:Vector.<Class> = new <Class>[ gui_00, heylee_01, tiles_01 ];
		private var atlasesNames:Array = [ "gui_00", "heylee_00", "tiles_00" ];
		private var objects:Array = [ { "klass":objects_00,"name":"tiles_00" } ];
		
		public function Atlases()
		{
			init();
		}
		
		public function init():void
		{
			for ( var i:int=0; i < sourceTextures.length;i++)
			{
				var xmlName:String = atlasesNames[i];
				var textureName:String = sourceTextures[i].toString();
				
				var xmlClass:Class = sourceAtlasesXML[i]; 
				var textureClass:Class = sourceTextures[i];
				
				var bitmap:Bitmap = new textureClass();
				var xml:XML = XML( new xmlClass() );
				var texture:Texture = Texture.fromBitmap(bitmap);
				var atlas:TextureAtlas = new TextureAtlas( texture, xml );
				
				atlases[xmlName] = atlas;
				textures[textureName] = texture;
			}
		}
		
		public static function getAtlas( name:String = "tiles_00" ):TextureAtlas
		{
			for ( var key:Object in Atlases.instance.atlases )
			{
				if ( ( key as String ).indexOf( name ) > -1 )
				{
					return Atlases.instance.atlases[key];
				}
			}
			
			return Atlases.instance.atlases[name];
		}
		
		public static function getTexture( atlasName:String, textureName:String ):Texture
		{
			//trace("++"+atlasName+"+"+textureName);
			var atlas:TextureAtlas = Atlases.instance.atlases[atlasName] as TextureAtlas;
			return atlas.getTexture( textureName );
		}
		
		public static function getObjects( atlasName:String ):XML
		{
			for each ( var o:Object in instance.objects )
			{
				if ( atlasName == o.name ) 
				{
					var c:Class = o.klass;
					var x:XML = XML( new c );
					return x;
				}
			}
			return null;
		}
	}
}