package mvc.config 
{
	
	import mvc.services.fullscreen.FullscreenService;
	import mvc.ui.console.mediators.ConsoleViewMediator;
	import mvc.ui.console.view.Console;
	import mvc.ui.editor.mediators.EditorViewMediator;
	import mvc.ui.editor.models.EditorModel;
	import mvc.ui.editor.views.EditorView;
	import mvc.ui.game.commands.GameStartCommand;
	import mvc.ui.game.events.GameEvent;
	import mvc.ui.game.models.GameModel;
	import mvc.ui.game.models.LevelModel;
	import mvc.ui.game.views.GameView;
	import mvc.ui.menu.mediators.MenuViewMediator;
	import mvc.ui.menu.views.MenuView;
	import mvc.ui.root.commands.AppStartupCommand;
	import mvc.ui.root.events.RootViewEvent;
	import mvc.ui.root.mediators.RootViewMediator;
	import mvc.ui.game.mediators.GameViewMediator;
	import mvc.ui.root.models.AppModel;
	import mvc.ui.stage.mediators.StarlingStageMediator;
	import mvc.ui.starling.mediators.StarlingRootMediator;
	import mvc.ui.starling.views.StarlingRoot;
	import mvc.ui.toolspanel.mediators.ToolsViewMediator;
	import mvc.ui.toolspanel.views.ToolsView;
	import robotlegs.bender.extensions.commandCenter.dsl.ICommandMapper;
	import robotlegs.bender.extensions.commandCenter.impl.CommandMapping;
	import robotlegs.bender.extensions.eventCommandMap.api.IEventCommandMap;
	import robotlegs.bender.extensions.mediatorMap.api.IMediatorMap;
	import robotlegs.bender.framework.api.IConfig;
	import robotlegs.bender.framework.api.IInjector;
	import starling.display.Stage;
	/**
	 * ...
	 * @author Roma Kraminskij - kraminskij@gmail.com
	 */
	public class MVCConfig implements IConfig 
	{
		[Inject]
		public var mediatorMap:IMediatorMap;
		
		[Inject]
		public var injector:IInjector;
		
		[Inject]
		public var commandMap:IEventCommandMap;
		
		public function MVCConfig() 
		{
			
		}
		
		/* INTERFACE robotlegs.bender.framework.api.IConfig */
		
		public function configure():void 
		{
			mediatorMap.map( RootView ).toMediator( RootViewMediator );
			mediatorMap.map( Stage ).toMediator( StarlingStageMediator );
			mediatorMap.map( GameView  ).toMediator( GameViewMediator );
			mediatorMap.map( Console ).toMediator( ConsoleViewMediator );
			mediatorMap.map( MenuView ).toMediator( MenuViewMediator );
			mediatorMap.map( StarlingRoot ).toMediator( StarlingRootMediator );
			mediatorMap.map( EditorView ).toMediator( EditorViewMediator );
			mediatorMap.map( ToolsView ).toMediator( ToolsViewMediator );
			
			injector.map( AppModel ).asSingleton();
			injector.map( GameModel ).asSingleton();
			injector.map( LevelModel ).asSingleton();
			injector.map( EditorModel ).asSingleton();
			injector.map( FullscreenService ).asSingleton();
			
			commandMap.map( RootViewEvent.ROOT_VIEW_CREATED, RootViewEvent ).toCommand( AppStartupCommand);
			commandMap.map( GameEvent.LEVEL_SELECTED, GameEvent ).toCommand( GameStartCommand );
		}
		
	}

}