package mvc.controls 
{
	import feathers.controls.ScrollContainer;
	import feathers.layout.HorizontalLayout;
	import feathers.layout.ILayout;
	import feathers.layout.VerticalLayout;
	
	/**
	 * ...
	 * @author Roma Kraminskij - kraminskij@gmail.com
	 * 
	 */
	public class Box extends ScrollContainer
	{
		public static const VERCTICAL_LAYOUT_TYPE  : int = 0;
		public static const HORIZONTAL_LAYOUT_TYPE : int = 1;
		
		public var layoutType:int = 0;
		public var percentWidth:int = -1;
		public var percentHeight:int = -1;
		
		public function Box( layoutType:int = VERCTICAL_LAYOUT_TYPE, isBorderEnabled:Boolean = false ) 
		{
			super();
			
			this.layoutType = layoutType; 
			
			var il:ILayout;
			
			if ( layoutType == VERCTICAL_LAYOUT_TYPE )
			{
				il = new VerticalLayout();
				( il as VerticalLayout ).horizontalAlign = VerticalLayout.HORIZONTAL_ALIGN_CENTER;
				( il as VerticalLayout ).verticalAlign = VerticalLayout.VERTICAL_ALIGN_MIDDLE;
				( il as VerticalLayout ).gap = 20;
			}
			else
			{
				il = new HorizontalLayout();
				( il as HorizontalLayout ).horizontalAlign = HorizontalLayout.HORIZONTAL_ALIGN_CENTER;
			}
			
			layout = il;
			
			if ( isBorderEnabled ) backgroundSkin = new Red9();
		}
		
		protected override function layoutChildren():void
		{
			super.layoutChildren();
			
			if ( percentWidth > -1 ) setSize( parent.width * percentWidth/100, this.height );
			if ( percentHeight > -1 ) setSize( this.width, parent.height * percentHeight/100 );
		}
		
	}

}