package mvc.services.fullscreen 
{
	import flash.display.Stage;
	import flash.display.StageDisplayState;
	import flash.events.Event;
	import flash.events.FullScreenEvent;
	import flash.events.IEventDispatcher;
	import flash.events.MouseEvent;
	import flash.geom.Rectangle;
	import lab.registry.Reg;
	import mvc.ui.console.view.Console;
	import mvc.ui.game.events.GameEvent;
	import starling.core.Starling;
	import lab.registry.Reg;
	/**
	 * ...
	 * @author Roma Kraminskij - kraminskij@gmail.com
	 */
	public class FullscreenService 
	{
		[Inject]
		public var dispatcher:IEventDispatcher;
		
		public function FullscreenService() 
		{
			
		}
		// BUG: Not working in browser.
		public function init():void
		{
			dispatcher.addEventListener( GameEvent.SWITCH_FULLSCREEN, switchFullscreenMode );
			setStageScaleMode();
		}
		
		/**
		 * 
		 * @param e
		 * 
		 */
		public function switchFullscreenMode( e : GameEvent ):void
		{
			Starling.current.nativeStage.addEventListener( MouseEvent.MOUSE_UP, fullScreenHandler );
		}
		
		
		/**
		 *  
		 * @param event
		 * 
		 */
		private function fullScreenHandler( event : * = null ) : void
		{
			var stage : Stage = Starling.current.nativeStage;
			
			stage.removeEventListener( MouseEvent.MOUSE_UP, fullScreenHandler );
			
			Console.log( "FullScreen enabled: " + stage.allowsFullScreen.toString() );
			
			if ( !stage.allowsFullScreen ) return;
			
			if ( stage.displayState == StageDisplayState.FULL_SCREEN_INTERACTIVE )
			{
				stage.displayState = StageDisplayState.NORMAL;
			}
			else
			{
				stage.displayState = StageDisplayState.FULL_SCREEN_INTERACTIVE;
			}
			
			Console.log( "FullScreen state: "+stage.displayState );
			
			setStageScaleMode();
			
			Starling.current.nativeStage.addEventListener( Event.RESIZE, setStageScaleMode );
		}
		
		/**
		 * Realign and resize viewport of Starling render.
		 * @param event
		 * 
		 */
		public function setStageScaleMode( event : Event = null ) : void
		{
			var stage : Stage = Starling.current.nativeStage;
			
			var width:int = Reg.GAME_WIDTH; var height:int = Reg.GAME_HEIGHT;
			var k:Number = Math.min(stage.stageWidth / width, stage.stageHeight / height);
			var w:int = width * k;
			var h:int = height * k;
			var x:int = (stage.stageWidth - w) * 0.5;
			var y:int = (stage.stageHeight - h) * 0.5;
			
			Starling.current.viewPort = new Rectangle( x, y, w, h );
			Starling.current.stage.stageWidth = width;
			Starling.current.stage.stageHeight = height;
			
			if ( event != null )
				Starling.current.nativeStage.removeEventListener(Event.RESIZE, setStageScaleMode);
		}
	}

}

		// Старый метод установки масштабирования старлинга на стейдже.
		// Возможно в нем есть более "вумные" методы.
		/**
		 * 
		 * 
		 * Выставляет метод масштабирования для старлинговского вьюпорта.
		 * @param value - Константы STRETCH, LETTERBOX, ZOOM, SMART. 
		 * @param width - Ширина игрового поля.
		 * @param height - Высота игрового поля.
		 * 
		 */
		/*
		 // Растягивает картинку без учёта соотношения сторон, заполняя весь экран
		public static const STRETCH:String = "ScaleMode.Stratch";
		// Сохраняет пропорции и центрирует картинку, оставляет полоски
		public static const LETTERBOX:String = "ScaleMode.LetterBox";
		// Сохраняет пропорции и увеличивает картинку пока она влезает в экран, оставляет полоски
		public static const ZOOM:String = "ScaleMode.Zoom";
		// Подстраивает размер картинки под размер экрана, "резиновый" дизайн
		public static const SMART:String = "ScaleMode.Smart";
		 
		public function setScaleMode( value:String, width:int, height:int ):void 
		{
			if ( value != STRETCH && value != LETTERBOX && value != ZOOM && value != SMART ) 
			{
				if (value != "") 
				{
					trace("Scale mode '" + value + "' not found.");
				}
				return;
			}
			
			if ( Starling.current == null || !Starling.current.isStarted )
			{
				return;
			}
			
			var stage:flash.display.Stage = Starling.current.nativeStage;
			
			switch( value ) 
			{
				case STRETCH:
					Starling.current.viewPort = new Rectangle( 0, 0, stage.stageWidth, stage.stageHeight );
					break;
				case LETTERBOX:
					var k:Number = Math.min( int( stage.stageWidth / width ), int( stage.stageHeight / height ) );
					var w:int = width * k;
					var h:int = height * k;
					var x:int = (stage.stageWidth - w) * 0.5;
					var y:int = (stage.stageHeight - h) * 0.5;
					Starling.current.viewPort = new Rectangle(x, y, w, h);
					Starling.current.stage.stageWidth = width;
					Starling.current.stage.stageHeight = height;
					break;
				case ZOOM:
					k = Math.min(stage.stageWidth / width, stage.stageHeight / height);
					w = width * k;
					h = height * k;
					x = (stage.stageWidth - w) * 0.5;
					y = (stage.stageHeight - h) * 0.5;
					Starling.current.viewPort = new Rectangle( x, y, w, h );
					Starling.current.stage.stageWidth = width;
					Starling.current.stage.stageHeight = height;
					break;
				case SMART:
					if (stage.stageWidth / width > stage.stageHeight / height) 
					{
						var s:int = stage.stageWidth / width;
						k = stage.stageWidth / stage.stageHeight;
						Starling.current.stage.stageWidth = stage.stageHeight * k / s;
						Starling.current.stage.stageHeight = stage.stageHeight / s;
					} 
					else 
					{
						s = stage.stageHeight / height;
						k = stage.stageHeight / stage.stageWidth;
						Starling.current.stage.stageWidth = stage.stageWidth / s;
						Starling.current.stage.stageHeight = stage.stageWidth * k / s;
					}
					Starling.current.viewPort = new Rectangle( 0, 0, stage.stageWidth, stage.stageHeight ); 
					break;
			}
		}
		
		
*/




















