package mvc.ui.console.mediators 
{
	//import citrus.core.CitrusEngine;
	import flash.events.IEventDispatcher;
	import flash.events.KeyboardEvent;
	import flash.events.MouseEvent;
	import flash.system.System;
	import flash.ui.Keyboard;
	import lab.registry.Reg;
	import mvc.ui.console.view.Console;
	import mvc.ui.game.events.GameEvent;
	import robotlegs.bender.extensions.starlingViewMap.impl.StarlingMediator;
	import starling.core.Starling;
	import starling.events.Event;
	
	/**
	 * ...
	 * @author Roma Kraminskij - kraminskij@gmail.com
	 */
	public class ConsoleViewMediator extends StarlingMediator 
	{
		[Inject]
		public var view:Console;
		
		[Inject]
		public var dispatcher:IEventDispatcher;
		
		private static const OBJECTS_TIMER_DELAY:uint = 2000;
		
		public function ConsoleViewMediator() 
		{
			
		}
		
		override public function initialize():void
		{
			view.b0.addEventListener( Event.TRIGGERED, touchCopyHandler );
			view.b1.addEventListener( Event.TRIGGERED, touchFullscreenHandler );
			view.b2.addEventListener( Event.TRIGGERED, touchHideHandler );
			
			Reg.i.stage.addEventListener( KeyboardEvent.KEY_UP, keyHandler );
		}
		
		private function touchHideHandler(e:Event=null):void 
		{
			view.visible = !view.visible;
		}
		
		override public function destroy():void
		{
			
		}
		
		private function touchFullscreenHandler(e:Event=null) : void 
		{
			dispatcher.dispatchEvent( new GameEvent( GameEvent.SWITCH_FULLSCREEN ) );
		}
		
		private function upFullscreenHandler( e : MouseEvent ):void 
		{
			Starling.current.nativeStage.removeEventListener( MouseEvent.MOUSE_UP, upFullscreenHandler );
		}
		
		private function touchCopyHandler( e : Event=null ):void
		{
			Starling.current.nativeStage.addEventListener( MouseEvent.MOUSE_UP, upCopyHandler );
		}
		
		private function upCopyHandler(e:MouseEvent):void 
		{
			Starling.current.nativeStage.removeEventListener( MouseEvent.MOUSE_UP, upCopyHandler );
			System.setClipboard( view.t1.text );
		}
		
		private function keyHandler( event:KeyboardEvent ):void
		{
			if ( event.keyCode == Keyboard.BACKQUOTE ) 
			{
				view.visible = !view.visible;
				if ( view.visible == true ) view.parent.setChildIndex( view, view.parent.numChildren - 1 );
			}
		}
	}

}