package mvc.ui.console.view
{
	import feathers.controls.Button;
	import feathers.controls.Label;
	import feathers.controls.Panel;
	import feathers.controls.ScrollContainer;
	import feathers.layout.HorizontalLayout;
	import feathers.layout.VerticalLayout;
	import flash.events.MouseEvent;
	import flash.events.TimerEvent;
	import flash.system.System;
	import flash.utils.Timer;
	import lab.registry.Reg;
	import mvc.controls.Box;
	import mvc.ui.levels.views.StarlingSubView;
	import starling.core.Starling;
	import starling.events.Event;
	import starling.events.Touch;
	import starling.events.TouchEvent;
	import starling.events.TouchPhase;
	import starling.utils.HAlign;
	
	import flash.events.KeyboardEvent;
	import flash.geom.Rectangle;
	
	import starling.display.Image;
	import starling.text.BitmapFont;
	import starling.text.TextField;
	import starling.textures.Texture;
	
	import lab.registry.Reg;
	
	/**
	 * @author Roma Kraminskij - kraminskij@gmail.com
	 * 
	 * 
	 */
	public class Console extends ScrollContainer
	{
		public static const WIDTH:uint = 550;
		public static const HEIGHT:uint = 400;
		
		private static var buffer:String = "";
		
		
		[Embed(source="//assets/fonts/font.ttf", fontName = "MechaBoldFont", mimeType = "application/x-font", 
		    embedAsCFF="false")]
		private var MechaBoldFont:Class;
		
		public var t1:TextField;
		public var t2:TextField;
		public var b0:Button = new Button(); // Copy log to clipboard.
		public var b1:Button = new Button(); // FullScreen.
		public var b2:Button = new Button(); // Hide console.

		public function Console()
		{
			super();
			
			paddingTop = 30;
			
			layout = new VerticalLayout();
			
			width = WIDTH;
			height = HEIGHT;
			
			var b:Box = new Box(Box.HORIZONTAL_LAYOUT_TYPE);
			b.percentWidth = 100;
			( b.layout as HorizontalLayout ).horizontalAlign = HorizontalLayout.HORIZONTAL_ALIGN_LEFT;
			( b.layout as HorizontalLayout ).verticalAlign = HorizontalLayout.VERTICAL_ALIGN_MIDDLE;
			( b.layout as HorizontalLayout ).gap = 4;
			
			addChild( b );
			
			var v:VerticalLayout = new VerticalLayout();
			v.verticalAlign = "top";
			layout = v;
			
			b.addChild( b2 );
			b2.label = "Hide";
			b2.scaleX = b2.scaleY = .45;
			
			b.addChild( b0 );
			b0.label = "Copy log";
			b0.scaleX = b0.scaleY = .45;
			
			b.addChild( b1 );
			b1.label = "Fullscreen";
			b1.scaleX = b1.scaleY = .45;
			
			t2 = new TextField(150, 30, "0", "MechaBoldFont", 14, 0xFF00FF, false ); 
			t2.border = true;
			t2.autoSize = "horizontal";
			b.addChild( t2 );
			
			t1 = new TextField(550, 160, "", "MechaBoldFont", 14, 0xFFFFFF, false ); 
			t1.border = true;
			t1.autoSize = "vertical";
			t1.hAlign = HAlign.LEFT;
			addChild( t1 );
			
			t1.text += buffer;
			
			backgroundSkin = new Image( Texture.fromColor( 16, 16, 0x88444444) );
			
			visible = false;
			
			Reg.i.console = this;
		}
		
		
		
		public static function log(text:String, color:uint = 0xFFFFFF ):void
		{
			if ( Reg.i.console == null )
			{
				buffer += text + "\n";
			}
			else
			{
				Reg.i.console.t1.text += text + "\n";
				trace(text);
			}
		}
	}
}