package mvc.ui.editor.views 
{
	import feathers.controls.Button;
	import feathers.controls.Panel;
	import feathers.core.FeathersControl;
	import feathers.core.IFeathersControl;
	import feathers.display.Scale9Image;
	import feathers.layout.VerticalLayout;
	import feathers.textures.Scale9Textures;
	import flash.geom.Rectangle;
	import lab.embed.Atlases;
	import mvc.controls.Box;
	import starling.core.Starling;
	
	/**
	 * ...
	 * @author Roma Kraminskij - kraminskij@gmail.com
	 */
	public class EditorView extends Panel 
	{
		public static const EDITOR_WIDTH_MUL:Number = 0.3;
		public static const BUTTONS_PANEL_HEIGHT:Number = 0.3;
		public static const OBJECTS_PANEL_HEIGHT:Number = 0.7;
		
		public var saveButton:Button = null;
		public var exitButton:Button = null;
		public var buttonsPanel:Box = null; // Buttons panel.
		public var objectsPanel:Box = null;
		public var list:ObjectsList = null;
		
		public function EditorView()
		{
			super();
			
			var r:Rectangle = Starling.current.viewPort;
			
			var sc0:Scale9Image = new Scale9Image( new Scale9Textures( Atlases.getTexture( "gui_00", "medium_bg0" ), new Rectangle(33,35,116,87) ) );
				
			this.backgroundSkin = sc0;
			
			setSize( Starling.current.stage.stageWidth * EDITOR_WIDTH_MUL, Starling.current.stage.stageHeight );
			
			buttonsPanel = new Box( Box.VERCTICAL_LAYOUT_TYPE, true );
			buttonsPanel.percentWidth = 100;
			buttonsPanel.height = Starling.current.stage.stageHeight * BUTTONS_PANEL_HEIGHT;
			addChild( buttonsPanel );
			
			objectsPanel = new Box( Box.VERCTICAL_LAYOUT_TYPE, true );
			objectsPanel.percentWidth = 100;
			objectsPanel.y = Starling.current.stage.stageHeight * BUTTONS_PANEL_HEIGHT;
			objectsPanel.height = Starling.current.stage.stageHeight * OBJECTS_PANEL_HEIGHT;
			addChild( objectsPanel );
			
			saveButton = new Button();
			saveButton.padding = 0;
			saveButton.label = "Copy";
			buttonsPanel.addChild( saveButton );
			
			exitButton = new Button();
			exitButton.label = "Exit";
			exitButton.padding = -10;
			buttonsPanel.addChild( exitButton );
			
			headerFactory = headerNuller;
			
			list = new ObjectsList( Starling.current.stage.stageWidth * EDITOR_WIDTH_MUL, Starling.current.stage.stageHeight * OBJECTS_PANEL_HEIGHT );
			
			objectsPanel.addChild( list );
		}
		
		private function headerNuller():IFeathersControl
		{
			var f:FeathersControl = new FeathersControl();
			f.setSize( 0, 0 )
			return f;
		}
		
	}

}