package mvc.ui.menu.mediators 
{
	import feathers.controls.Button;
	import flash.events.IEventDispatcher;
	import lab.registry.Reg;
	import mvc.controls.Box;
	import mvc.ui.game.events.GameEvent;
	import mvc.ui.menu.views.MenuView;
	import robotlegs.bender.extensions.starlingViewMap.impl.StarlingMediator;
	import starling.core.Starling;
	import starling.events.Event;
	import starling.events.TouchEvent;
	import lab.registry.Reg;
	
	/**
	 * ...
	 * @author Roma Kraminskij - kraminskij@gmail.com
	 */
	public class MenuViewMediator extends StarlingMediator 
	{
		[Inject]
		public var view:MenuView;
		
		[Inject]
		public var dispatcher:IEventDispatcher;
		
		private var isRunEditor:Boolean = false;
		
		public function MenuViewMediator() 
		{
			
		}
		
		override public function initialize():void
		{
			view.playButton.addEventListener( Event.TRIGGERED, playHandler );
			view.optionsButton.addEventListener( Event.TRIGGERED, optionsHandler );
			view.levels.addEventListener( Event.TRIGGERED, levelsHandler );
			view.editorButton.addEventListener( Event.TRIGGERED, editorHandler );
			
			view.levels.onLevelSelected.add( levelsHandler );
			
			view.place();
		}
		
		private function editorHandler(e:Event):void 
		{
			isRunEditor = true;
			playHandler( null, 1 );
		}
		
		private function levelsHandler( level:int = -1 ):void 
		{
			playHandler( null, level );
		}
		
		private function optionsHandler(e:Event):void 
		{
			
		}
		
		private function playHandler( e:Event = null, level:int = -1 ):void 
		{
			view.i.removeFromParent( true );
			view.removeFromParent(true);
			
			var ge:GameEvent = new GameEvent( GameEvent.LEVEL_SELECTED );
			ge.selectedLevel  = ( level < 1 ) ? 1 : level;
			ge.isRunEditor = isRunEditor;
			dispatcher.dispatchEvent( ge );
		}
		
		override public function destroy():void
		{
			view.playButton.removeEventListener( TouchEvent.TOUCH, playHandler );
			view.optionsButton.removeEventListener( TouchEvent.TOUCH, optionsHandler );
		}
	}

}