package mvc.ui.menu.views 
{
	import feathers.controls.ScrollContainer;
	import feathers.layout.HorizontalLayout;
	import lab.embed.Atlases;
	import mvc.controls.Box;
	import mvc.ui.game.events.GameEvent;
	import org.osflash.signals.Signal;
	import starling.display.Image;
	import starling.events.Event;
	
	/**
	 * ...
	 * @author Roma Kraminskij - kraminskij@gmail.com
	 */
	
	public class LevelsList extends Box
	{
		public var onLevelSelected:Signal = new Signal( int );
		
		public function LevelsList( layoutType:int = Box.HORIZONTAL_LAYOUT_TYPE, levels:Vector.<Class> = null ) 
		{
			super( layoutType );
			
			( layout as HorizontalLayout ).gap = 10;
			
			width = 436;
			
			var c:int = 1;
			
			for each ( var klass:Class in levels )
			{
				var b:LevelButton = new LevelButton();
				b.level = c;
				this.addChild( b );
				b.defaultSkin = new Image( Atlases.getTexture( "gui_00", "medium_bg0" ) );
				b.addEventListener( Event.TRIGGERED, touchHandler );
				b.label = c.toString();
				b.width = b.height = 50;
				c++;
			}
		}
		
		private function touchHandler( e : Event ):void 
		{
			if ( e.target is LevelButton )
			{
				onLevelSelected.dispatch( (e.target as LevelButton ).level ) ;
				( e.target as LevelButton ).removeEventListener( Event.TRIGGERED, touchHandler );
				onLevelSelected.removeAll();
			}
		}
		
	}

}
















