/*
Copyright (c) 2008 De Pannekoek en De Kale B.V.,  www.dpdk.nl

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.
 */
package nl.dpdk.services.fms.user 
{
	import nl.dpdk.services.fms.user.RemoteId;
	import flash.events.Event;		

	/**
	 * event that is used with a remote id
	 * 
	 * @see RemoteId
	 * 
	 * @author Rolf Vreijdenberger
	 */
	public class RemoteIdEvent extends Event {
		//we are holding a remote id
		public static const REMOTE_ID : String = 'remote id';
		//failure getting the remote id, possibly the method is not available on the FMS.
		public static const REMOTE_ID_FAILURE:String = 'remote id failure';
		private var remoteId : RemoteId;

		public function RemoteIdEvent(type : String, remoteId : RemoteId = null) {
				
			super(type, false, false);
			setRemoteId(remoteId);
		}

		
		public override function clone() : Event {
			return new RemoteIdEvent(type, remoteId);
		}

	

		override public function toString() : String {
			return "RemoteIdEvent";
		}
		
		public function getRemoteId() : RemoteId {
			return remoteId;
		}
		
		public function setRemoteId(remoteId : RemoteId) : void {
			this.remoteId = remoteId;
		}
	}
}
